//+------------------------------------------------------------------+
//|                                               BBands_Stop_v1.mq4 |
//|                           Copyright  2006, TrendLaboratory Ltd. |
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |
//|                                       E-mail: igorad2004@list.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, TrendLaboratory Ltd."
#property link      "http://finance.groups.yahoo.com/group/TrendLaboratory"

#property indicator_chart_window
#property indicator_buffers 6
#property indicator_color1 Teal
#property indicator_color2 FireBrick  
#property indicator_color3 Aqua
#property indicator_color4 DeepPink
#property indicator_color5 LightSeaGreen
#property indicator_color6 MediumVioletRed
#property indicator_width1 0
#property indicator_width2 0
#property indicator_width3 2
#property indicator_width4 2


//---- input parameters
extern int    Length=20;      // Bollinger Bands Period
extern int    Deviation=2;    // Deviation
extern double x=0;    // Tune
extern double MoneyRisk=1.00; // Offset Factor
extern int    Signal=1;       // Display signals mode: 1-Signals & Stops; 0-only Stops; 2-only Signals;
extern int    Line=1;         // Display line mode: 0-no,1-yes  
extern int    Nbars=1000;
extern color TextColor2=Yellow;

// Set Expired Date
#include "DateExpire.h"

//---- indicator buffers
double UpTrendBuffer[];
double DownTrendBuffer[];
double UpTrendSignal[];
double DownTrendSignal[];
double UpTrendLine[];
double DownTrendLine[];


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
  int init()
  {
   string short_name;
//---- indicator line   
   SetIndexBuffer(0,UpTrendBuffer);
   SetIndexBuffer(1,DownTrendBuffer);
   SetIndexBuffer(2,UpTrendSignal);
   SetIndexBuffer(3,DownTrendSignal);
   SetIndexBuffer(4,UpTrendLine);
   SetIndexBuffer(5,DownTrendLine);
   SetIndexStyle(0,DRAW_ARROW);
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexStyle(2,DRAW_ARROW);
   SetIndexStyle(3,DRAW_ARROW);
   
   SetIndexStyle(4,DRAW_LINE);
   SetIndexStyle(5,DRAW_LINE);
   SetIndexArrow(0,108);
   SetIndexArrow(1,108);
   SetIndexArrow(2,233);  //head up arrow
   SetIndexArrow(3,234);  //head down arrow
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));
//---- name for DataWindow and indicator subwindow label
   short_name="BBands Stop("+Length+","+Deviation+")";
   IndicatorShortName(short_name);
   SetIndexLabel(0,"UpTrend Stop");
   SetIndexLabel(1,"DownTrend Stop");
   SetIndexLabel(2,"UpTrend Signal");
   SetIndexLabel(3,"DownTrend Signal");
   SetIndexLabel(4,"UpTrend Line");
   SetIndexLabel(5,"DownTrend Line");
//----
   SetIndexDrawBegin(0,Length);
   SetIndexDrawBegin(1,Length);
   SetIndexDrawBegin(2,Length);
   SetIndexDrawBegin(3,Length);
   SetIndexDrawBegin(4,Length);
   SetIndexDrawBegin(5,Length);
//----
  }

//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
    ObjectDelete("COMPANY_LABEL");

    return(0);
  }


//+------------------------------------------------------------------+
//| Custom functions                                                 |
//+------------------------------------------------------------------+
 int CompanyLabel()
  {
    if(ObjectFind("COMPANY_LABEL") != 0)
    {
      ObjectCreate("COMPANY_LABEL", OBJ_LABEL,0,0,0);
      ObjectSetText("COMPANY_LABEL","www.RichardConsultancy.com" , 10, "Arial", Yellow);
      ObjectSet("COMPANY_LABEL", OBJPROP_XDISTANCE,250);
      ObjectSet("COMPANY_LABEL", OBJPROP_YDISTANCE,0);
      return(1);
    }
    else
    {
      ObjectMove("COMPANY_LABEL", 0, 0, 0);
      return(0);
    }
 }






// Return 0=Expired, 1=Valid Date
int DateExpire()
  {   
    // ----------------- Expired ---------------------
    if ((Year()>expired_year) || (Year()==expired_year && Month()>expired_month) || (Year()==expired_year && Month()==expired_month && Day()>expired_day))
    {
      if(ObjectFind("DATE_EXPIRE") != 0)
      {
        ObjectCreate("DATE_EXPIRE", OBJ_LABEL, 0,0,0);
        ObjectSetText("DATE_EXPIRE","Indicator Expired.www.richardconsultancy.com or richardforex2u@gmail.com" , 24, "Arial", Red);
        ObjectSet("DATE_EXPIRE", OBJPROP_XDISTANCE,150);
        ObjectSet("DATE_EXPIRE", OBJPROP_YDISTANCE,200);
      }
      else
      {
        ObjectMove("DATE_EXPIRE", 0, Time[0], WindowPriceMax());
      }
      return(0);
    }
    // ----------------- Valid ---------------------
    else
    {
      // === Mask Expire Date Display, Start Here
      /*
      if(ObjectFind("DATE_EXPIRE") != 0)
      {
        ObjectCreate("DATE_EXPIRE", OBJ_LABEL, 0,0,0);
        ObjectSetText("DATE_EXPIRE","the indicator well expire after ( " + expired_day+"-"+expired_month+"-"+expired_year+" )", 10, "Arial", Red);
        ObjectSet("DATE_EXPIRE", OBJPROP_XDISTANCE,465);
        ObjectSet("DATE_EXPIRE", OBJPROP_YDISTANCE,0);
      }
      else
      {
        ObjectMove("DATE_EXPIRE", 0, Time[0], WindowPriceMax());
      }
      */
      // === Mask Expire Date Display, End Here
      return(1);
    }
  }


//+------------------------------------------------------------------+
//| Bollinger Bands_Stop_v1                                             |
//+------------------------------------------------------------------+
int start()
  {
   int    i,shift,trend;
   double smax[25000],smin[25000],bsmax[25000],bsmin[25000];

   CompanyLabel();
   if(DateExpire()==0) return(0);  // Quit if expired
       
   for (shift=Nbars;shift>=0;shift--)
   {
   UpTrendBuffer[shift]=0;
   DownTrendBuffer[shift]=0;
   UpTrendSignal[shift]=0;
   DownTrendSignal[shift]=0;
   UpTrendLine[shift]=EMPTY_VALUE;
   DownTrendLine[shift]=EMPTY_VALUE;
   }
   
   for (shift=Nbars-Length-1;shift>=0;shift--)
   {	
     smax[shift]=iBands(NULL,0,Length,Deviation,0,PRICE_CLOSE,MODE_UPPER,shift);
	  smin[shift]=iBands(NULL,0,Length,Deviation,0,PRICE_CLOSE,MODE_LOWER,shift);
	
	  if (Close[shift]>smax[shift+1]) trend=1; 
	  if (Close[shift]<smin[shift+1]) trend=-1;
		 	
	  if(trend>0 && smin[shift]<smin[shift+1]) smin[shift]=smin[shift+1];
	  if(trend<0 && smax[shift]>smax[shift+1]) smax[shift]=smax[shift+1];
	  	  
	  bsmax[shift]=smax[shift]+0.5*(MoneyRisk-1)*(smax[shift]-smin[shift]);
	  bsmin[shift]=smin[shift]-0.5*(MoneyRisk-1)*(smax[shift]-smin[shift]);
		
	  if(trend>0 && bsmin[shift]<bsmin[shift+1]) bsmin[shift]=bsmin[shift+1];
	  if(trend<0 && bsmax[shift]>bsmax[shift+1]) bsmax[shift]=bsmax[shift+1];
	  
	  if (trend>0) 
	  {
	     if (Signal>0 && UpTrendBuffer[shift+1]==-1.0)
	     {
	     UpTrendSignal[shift]=bsmin[shift];
	     UpTrendBuffer[shift]=bsmin[shift];
	     if(Line>0) UpTrendLine[shift]=bsmin[shift];
	     }
	     else
	     {
	     UpTrendBuffer[shift]=bsmin[shift];
	     if(Line>0) UpTrendLine[shift]=bsmin[shift];
	     UpTrendSignal[shift]=-1;
	     }
	  if (Signal==2) UpTrendBuffer[shift]=0;   
	  DownTrendSignal[shift]=-1;
	  DownTrendBuffer[shift]=-1.0;
	  DownTrendLine[shift]=EMPTY_VALUE;
	  }
	  if (trend<0) 
	  {
	  if (Signal>0 && DownTrendBuffer[shift+1]==-1.0)
	     {
	     DownTrendSignal[shift]=bsmax[shift];
	     DownTrendBuffer[shift]=bsmax[shift];
	     if(Line>0) DownTrendLine[shift]=bsmax[shift];
	     }
	     else
	     {
	     DownTrendBuffer[shift]=bsmax[shift];
	     if(Line>0)DownTrendLine[shift]=bsmax[shift];
	     DownTrendSignal[shift]=-1;
	     }
	  if (Signal==2) DownTrendBuffer[shift]=0;    
	  UpTrendSignal[shift]=-1;
	  UpTrendBuffer[shift]=-1.0;
	  UpTrendLine[shift]=EMPTY_VALUE;
	  }
	  
	 }
	return(0);	
 }

